/*-
 * Copyright (C) 2009-2010 Semihalf, Grzegorz Bernacki
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $FreeBSD$
 */

#ifndef _NANDBUS_H_
#define _NANDBUS_H_

struct nandbus_ivar {
	uint8_t	cs;
	uint8_t man_id;
	uint8_t dev_id;
	uint8_t is_onfi;
	char	*chip_cdev_name;
};

extern devclass_t	nandbus_devclass;
extern driver_t		nandbus_driver;

int  nandbus_create(device_t nfc);
void nandbus_destroy(device_t nfc);

int nandbus_get_status(device_t dev, uint8_t *status);
void nandbus_read_buffer(device_t dev, void *buf, uint32_t len);
int nandbus_select_cs(device_t dev, uint8_t cs);
int nandbus_send_command(device_t dev, uint8_t command);
int nandbus_send_address(device_t dev, int32_t row, int32_t col, int8_t off);
int nandbus_start_command(device_t dev);
int nandbus_wait_ready(device_t dev, uint8_t *status);
void nandbus_write_buffer(device_t dev, void *buf, uint32_t len);

void nandbus_lock(device_t dev);
void nandbus_unlock(device_t dev);

#endif /* _NANDBUS_H_ */
